package org.javagroup.tools.processmanager;

import org.javagroup.process.*;
import org.javagroup.util.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.CellEditor;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;

public class ProcessWatcherPanel extends JPanel implements ActionListener
{

  /** Table containing process info **/
  protected JTable _processTable;
  protected JButton _killButton;
  protected ProcessDataModel _dataModel;

  private static final int __MINIMUM_HEIGHT = 200;
  public  static final int CLICK_DURATION = 1000;

  public ProcessWatcherPanel() {

    ProcessDataModel myDataModel = new ProcessDataModel();
    _dataModel = myDataModel;
    JTable table = new JTable(myDataModel);
    _processTable = table;

    table.setRowSelectionAllowed(true);
    table.setColumnSelectionAllowed(false);
    table.setCellSelectionEnabled(false);
    table.setSelectionMode(0); // SINGLE_SELECTION
    //FontMetrics fm=table.getFontMetrics(table.getFont());
    JCheckBox cb=new JCheckBox();
    Insets ins=cb.getInsets();
    //int bestWidth=ins.left+ins.right+javax.swing.SwingUtilities.computeStringWidth(fm,"00");
    //int maxWidth=ins.left+ins.right+javax.swing.SwingUtilities.computeStringWidth(fm,"00000");
    TableColumn tCol=table.getColumn(table.getModel().getColumnName(ProcessDataModel.C_PID));
    //tCol.setWidth(bestWidth);
    //tCol.setMinWidth(bestWidth);
    //tCol.setMaxWidth(maxWidth);
    tCol.setCellRenderer(new DefaultTableCellRenderer());
    tCol.setCellEditor(new DefaultCellEditor(cb));


/*
	for (int columnIndex = 0; 
	columnIndex < myDataModel.numColumns;
	columnIndex++) {
	TableColumn newColumn =
	new TableColumn();//myDataModel.getColumnName(columnIndex));
	table.addColumn(newColumn);
	newColumn.sizeWidthToFit();
	}
*/
    //Create the scroll pane and add the table to it. 
    JScrollPane scrollPane = JTable.createScrollPaneForTable(table);

    //Make the table heads be the non-scrolling column header.
    //JViewport columnHeading = new JViewport();
    //columnHeading.setView(table.getTableHeader());
    //columnHeading.setLayout(new BoxLayout(columnHeading,    //HACK
		//			  BoxLayout.X_AXIS));
    //scrollPane.setColumnHeader(columnHeading);

    _killButton = new JButton("Kill process");
    _killButton.addActionListener(this);

    this.setLayout(new BorderLayout());
    this.add("Center", scrollPane);
    this.add("South", _killButton);
  }

  public Dimension getPreferredSize() {
    Dimension pref_size = super.getPreferredSize();
    return
      new Dimension(pref_size.width,
										Math.max(__MINIMUM_HEIGHT, pref_size.height));
  }

  protected void killCurrentSelection() {
    if (_processTable.getSelectedRow() >= _processTable.getRowCount())
			return;
		
    try {
      long pid;
      pid =
				Long.parseLong((String)_dataModel
											 .getValueAt(_processTable.getSelectedRow(),ProcessDataModel.C_PID));
      ProcessManagerHolder.getProcessManager().kill(pid);
    }
    catch (Exception e) {
			e.printStackTrace();
    }
  }

  public void actionPerformed(ActionEvent event) {

    killCurrentSelection();

  }

}

